//////////////////////////////////
//  d^dvU  adconv.c    //
//  2010/12/13  18F2420  C18    //
//////////////////////////////////

#include "global.h"

#define ST_AD_INI 0
#define ST_AD_BAT 1
#define ST_AD_VIN 2
#define ST_AD_IIL 3
#define ST_AD_IIM 4
#define ST_AD_IIS 5
#define ST_AD_END 6

uint ad_res[5];                              //A/Dϊ
//idrdAdvAdvAdvAdvj
static uint ad_add[5];                       //A/DZobt@
static uint samp_cnt;                        //TvO
static uchar state;
uchar ad_flg;                               //A/D

/////////   A/D
void ad_init(void)
{
    ADCON1 = 0b00011011;    //AN0,AN1,AN2,AN3=VREF+
    ADCON2 = 0b10100001;    //El߁A8Tad,Fosc/8
    state = ST_AD_INI;
    samp_cnt =0;
    ad_flg = 0;
}
////////   ADϊ
int ad_conv(uchar ch){
    ADDATA addata;

    ADCON0 = ch << 2;           //CH SET
    ADCON0bits.ADON = 1;        //AD ON
    ADCON0bits.GO = 1;          //A/D START
    while(ADCON0bits.GO);       //҂
    addata.adb[0] = ADRESL;
    addata.adb[1] = ADRESH;
    return addata.adw;
}
////////  A/Dϊʂۑ
void ad_samp(void){
    uchar port;
    int i;
    
    switch(state){
        case ST_AD_INI:
            for(i = 0;i < 5; i++){
                ad_add[i] = 0;
            }
            samp_cnt = 0;
            state = ST_AD_BAT;
            timer_start(TIMER_AD,5);
            break;
        case ST_AD_BAT:                 //drdv
            if(!timer_check(TIMER_AD))return;
            ad_add[0] += ad_conv(0);
            state = ST_AD_VIN;
            timer_start(TIMER_AD,5);
            break;
        case ST_AD_VIN:                 //dv
            if(!timer_check(TIMER_AD))return;
            ad_add[1] += ad_conv(1);
            state = ST_AD_IIL;
            LATBbits.LATB0 = 1;
            LATBbits.LATB1 = 0;
            timer_start(TIMER_AD,5);
            break;
        case ST_AD_IIL:                 //dv
            if(!timer_check(TIMER_AD))return;
            ad_add[2] += ad_conv(2);
            state = ST_AD_IIM;
            LATBbits.LATB0 = 0;
            LATBbits.LATB1 = 1;
            timer_start(TIMER_AD,5);
            break;
        case ST_AD_IIM:                 //dv
            if(!timer_check(TIMER_AD))return;
            ad_add[3] += ad_conv(2);
            state = ST_AD_IIS;
            LATBbits.LATB0 = 1;
            LATBbits.LATB1 = 1;
            timer_start(TIMER_AD,5);
            break;
        case ST_AD_IIS:                 //dv
            if(!timer_check(TIMER_AD))return;
            ad_add[4] += ad_conv(2);
            state = ST_AD_END;
            samp_cnt++;
            break;
        case ST_AD_END:
            if (samp_cnt < 64){
                state = ST_AD_BAT;
                timer_start(TIMER_AD,5);
                return;
            }
            for (i = 0;i < 5;i++){
                ad_add[i] += 32;        //1/2Z
                ad_res[i] = ad_add[i]/64;
            }
            state = ST_AD_INI;
            ad_flg = 1;
            break;
    }
}
