///////////////////////////////////
//  d^dvU  display.c    //
//  2010/12/13  PIC18F2420  C18  //
///////////////////////////////////
#include "global.h"

#define VBAT 0
#define VIN  1
#define IIL  2
#define IIM  3
#define IIS  4
#define LOW_BOLT 2000   //mV

void (* func[])(void) = {
    current0,           //d\I[gW
    current1,           //\z[hiȂj
    current2,           //dWɌŒ
    current3,           //dWɌŒ
    current4            //dWɌŒ
};
MODE mode;
rom const char *dispmode[] = {"NOM","HLD","HC1","HC2","HC3"};

/////////   d\
void lcd_volt(int v){
    int n1,n2,n3,n4;
    n1 = v / 1000;
    v = v % 1000;
    n2 = v / 100;
    v = v % 100;
    n3 = v / 10;
    n4 = v % 10;
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    lcd_data(n2 + 0x30);
    lcd_data('.');
    lcd_data(n3 + 0x30);
    lcd_data(n4 + 0x30);
    lcd_data('V');
}
/////////   d\Pidj
void lcd_cur1(int c){
    int n1,n2,n3,n4;
    n1 = c / 1000;
    c = c % 1000;
    n2 = c / 100;
    c = c % 100;
    n3 = c / 10;
    n4 = c % 10;
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    if(n1 || n2)lcd_data(n2 + 0x30);
    else lcd_data(' ');
    lcd_data(n3 + 0x30);
    lcd_data('.');
    lcd_data(n4 + 0x30);
    lcd_data('m');
    lcd_data('A');
}
/////////   d\Qidj
void lcd_cur2(int c){
    int n1,n2,n3,n4;
    n1 = c / 1000;
    c = c % 1000;
    n2 = c / 100;
    c = c % 100;
    n3 = c / 10;
    n4 = c % 10;
    lcd_data(' ');          //\ʒu킹
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    if(n1 || n2)lcd_data(n2 + 0x30);
    else lcd_data(' ');
    if(n1 || n2 || n3)lcd_data(n3 + 0x30);
    else lcd_data(' ');
    lcd_data(n4 + 0x30);
    lcd_data('m');
    lcd_data('A');
}
/////////   d\Ridj
void lcd_cur3(int c){
    int n1,n2,n3,n4;
    n1 = c / 1000;
    c = c % 1000;
    n2 = c / 100;
    c = c % 100;
    n3 = c / 10;
    n4 = c % 10;
    lcd_data(' ');          //\ʒu킹
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    lcd_data(n2 + 0x30);
    lcd_data('.');
    lcd_data(n3 + 0x30);
    lcd_data(n4 + 0x30);
    lcd_data('A');
}
/////////   dv
void voltage(void){
    int volt;
    long buff;

    if(ad_res[VIN] == 0x3ff){
        lcd_cmd(0x80);
        lcd_str_rom("-----V");
        lcd_cmd(0xc0);
        lcd_str_rom("OFV");     //dI[o[t[\
    }
    else{
        lcd_cmd(0x80);
        buff = (long)ad_res[1]*3L;          //1bit 30mV
        if(buff < 10L) buff*=1700L;         //QC␳
        else if(buff < 20L) buff*=1400L;
        else if(buff < 31L) buff*=1200L;
        else if(buff < 63L) buff*=1100L;
        else if(buff < 100L) buff*=1070L;
        else if(buff < 150L) buff*=1043L;
        else if(buff < 250L) buff*=1018L;
        else if(buff < 500L) buff*=1008L;
        else if(buff < 800L) buff*=1003L;
        else if(buff < 1500L) buff*=1002L;
        else buff*=1000L;
        buff = buff / 1000L;
        volt = (int)buff;
        lcd_volt(volt);         //d\
        lcd_cmd(0xc0);    
        lcd_str_rom("   ");
    }
}
/////////   dvij
void current0(void){
    int curr;
    long buff;

    buff = (long)ad_res[IIM] * 1009L;           //܂dŃX^[g
    buff = buff / 1000L;                        //QC␳
    curr = (int)buff;                           //1bit 1mA
    if(curr > 999){                             //Wグ
        if(ad_res[IIL] == 0x3ff){               //dWŃI[o[t[
            lcd_cmd(0x88);
            lcd_str_rom("------A");
            lcd_cmd(0xc4);
            lcd_str_rom("OFI");
            return;
        }
        else{
            buff = (long)ad_res[IIL] * 1007L;   //dW̌vZ
            buff = buff / 1000L;                //QC␳i킹݁j
            curr = (int)buff;                   //1bit 10mA
            if(curr < 100)curr = 100;
            lcd_cmd(0x88);
            lcd_cur3(curr);
            lcd_cmd(0xc4);
            lcd_str_rom("   ");
            return;
        }
    }
    if(curr < 100){                         //dW
        buff = (long)ad_res[IIS] * 1000L;
        buff = buff / 1012L;                //QC␳i킹݁j
        curr = (int)buff;                   //1bit 0.1mA
        if(curr > 999) curr = 999;
        lcd_cmd(0x88);
        lcd_cur1(curr);
        lcd_cmd(0xc4);
        lcd_str_rom("   ");
        return;
    }
    lcd_cmd(0x88);                          //d̕\
    lcd_cur2(curr);
    lcd_cmd(0xc4);
        lcd_str_rom("   ");
}
/////////   dvid\Œj
void current2(void){
    int curr;
    long buff;

    if(ad_res[IIS] == 0x3ff){               //dvADOa
        lcd_cmd(0x88);
        lcd_str_rom("-----mA");
        lcd_cmd(0xc4);
        lcd_str_rom("OFI");
    }
    else {                                  //dv
        buff = (long)ad_res[IIS] * 1000L;
        buff = buff / 1012L;                //QC␳
        curr = (int)buff;
        lcd_cmd(0x88);
        lcd_cur1(curr);
        lcd_cmd(0xc4);
        lcd_str_rom("   ");
    }
}
/////////   dvid\Œj
void current3(void){
    int curr;
    long buff;

    if(ad_res[IIM] == 0x3ff){               //dŃI[o[t[
        lcd_cmd(0x88);
        lcd_str_rom("-----mA");
        lcd_cmd(0xc4);
        lcd_str_rom("OFI");
    }
    else {
        buff = (long)ad_res[IIM] * 1009L;   //dv
        buff = buff / 1000L;                //␳
        curr = (int)buff;
        lcd_cmd(0x88);
        lcd_cur2(curr);
        lcd_cmd(0xc4);
        lcd_str_rom("   ");
    }
}
/////////   dvidŒj
void current4(void){
    int curr;
    long buff;

    if(ad_res[IIL] == 0x3ff){
        lcd_cmd(0x88);
        lcd_str_rom("------A");
        lcd_cmd(0xc4);
        lcd_str_rom("OFI");
    }
    else {
        buff = (long)ad_res[IIL] * 1007L;
        buff = buff / 1000L;
        curr = (int)buff;
        lcd_cmd(0x88);
        lcd_cur3(curr);
        lcd_cmd(0xc4);
        lcd_str_rom("   ");
    }
}
/////////   dviz[hj
void current1(void){
    Delay100TCYx(CONFIG_MHZ);       //400uS
}
/////////   dr`FbN
void battery(void){
    int bv;
    bv = ad_res[VBAT]*3;
    lcd_cmd(0xcc);
    if(bv < LOW_BOLT) lcd_str_rom("BVL");
    else lcd_str_rom("   ");
}

////////   \
void display(void){
    if(!ad_flg)return;
    if(mode == HLD) Delay100TCYx(CONFIG_MHZ);   //400uS
    else voltage();                             //dv
    func[mode]();                               //dv
    lcd_cmd(0xc8);
    if(!blink_flg) lcd_str_rom(dispmode[mode]);
    else lcd_str_rom("   ");
    battery();                                  //drdv
    ad_flg = 0;
}
