///////////////////////////////////
//  d^dvU  global.h     //
//  2010/12/13  PIC18F2420  C18  //
///////////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

///// CPU Type
#include <p18f2420.h>

///// ^̒Zk
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

///// Delay
#include <delays.h>
#define CONFIG_MHZ 4

///// Timer
#define TIMER_NUM           4
#define TIMER_AD            0
#define TIMER_MODE          1
#define TIMER_MINUTE        2

extern volatile uint tics;
extern void timer_init(void);
extern void timer_start(int, uint);
extern void timer_restart(int, uint);
extern void timer_cancel(int);
extern int timer_check(int);
extern int timer_check_start(int);

///// Lcd
#define     lcd_port    LATC
#define     lcd_stb     LATCbits.LATC5
#define     lcd_rs      LATCbits.LATC4

extern void lcd_init(void);
extern void lcd_clear(void);
extern void lcd_cmd(char);
extern void lcd_data(char);
extern void lcd_str(char *);
extern void lcd_str_rom(rom const char *);

///// display
typedef enum {NOM,HLD,HC1,HC2,HC3,OVR}MODE;
extern  MODE mode;         //d\[h
extern void display(void);
extern void current0(void);
extern void current1(void);
extern void current2(void);
extern void current3(void);
extern void current4(void);

///// main
extern uchar blink_flg;

///// A/d
typedef union{
    uint adw;
    uchar adb[2];
}ADDATA;
extern ADDATA addata;
extern uint ad_res[];
extern uchar ad_flg;
extern void ad_init(void);
extern void ad_samp(void);

#endif
