///////////////////////////////////
//  d^dvU  timer.c      //
//  2010/08/20  PIC18F2420  C18  //
///////////////////////////////////

#include "global.h"

static uint set_time[TIMER_NUM]; //^C}[ݒl
static uint start_time[TIMER_NUM]; //Jn̒l

volatile uint tics;

void timer_init(void){
    int n;

    T1CON = 0x81;           //Timer1 16bit,ps1/1,enable
    TMR1H = 0;              //Timer1 clear
    TMR1L = 0;
    PIE1bits.TMR1IE = 0;    //Timer1 荞݋֎~

    CCP1CON = 0xb;          //Special Event
#if (CONFIG_MHZ == 4)       //ccp data
    CCPR1H = 0x3;
    CCPR1L = 0xe8;
#elif (CONFIG_MHZ == 8)
    CCPR1H = 0x7;
    CCPR1L = 0xd0;
#elif (CONFIG_MHZ == 10)
    CCPR1H = 0x9;
    CCPR1L = 0xc4;
#elif (CONFIG_MHZ == 16)
    CCPR1H = 0xf;
    CCPR1L = 0xa0;
#elif (CONFIG_MHZ == 20)
    CCPR1H = 0x13;
    CCPR1L = 0x88;
#elif (CONFIG_MHZ == 32)
    CCPR1H = 0x1f;
    CCPR1L = 0x40;
#elif (CONFIG_MHZ == 40)
    CCPR1H = 0x27;
    CCPR1L = 0x10;
#else
    CCPR1H = 0x7;
    CCPR1L = 0xd0;
#endif

    IPR1bits.CCP1IP = 1;    //荞ݗD惌xʑɂĂ
    PIE1bits.CCP1IE = 1;    //bbo荞݋
    
    for(n = 0; n < TIMER_NUM; n++) set_time[n] = 0;
}

void timer_start(int num, uint time){
    if(set_time[num]) return;
    set_time[num] = time;
    start_time[num] = tics;
}

void timer_restart(int num, uint time){
    set_time[num] = time;
    start_time[num] = tics;
}

void timer_cancel(int num){
    set_time[num] = 0;
}

int timer_check(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    set_time[num] = 0;
    return 1;
}

int timer_check_start(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    start_time[num] = tics;
    return 1;
}

#pragma interrupt isr
#pragma code isrcode = 0x8  
void jump_isr(void){            //荞݊֐փWviO͉łǂj
    _asm
    goto isr
    _endasm
}

#pragma code
void isr(void){                 //荞݊֐iO͉łǂj
    if (PIR1bits.CCP1IF){       //bboP荞ݗv
        PIR1bits.CCP1IF = 0;    //荞݃tO̓NAĂ
        tics++;
    }
}
